
% Programming Assignment I

close all
clear 
% name of the input file
imname = '01880v.jpg';

% read in the glass plate input image
fullim = imread(imname);

% convert to double matrix 
fullim = im2double(fullim);

% compute the height of each part (just 1/3 of total)
height = floor(size(fullim,1)/3);
widht = floor(size(fullim,2));

% divide the input image into three color channels
B = fullim(1:height,:);
G = fullim(height+1:height*2,:);
R = fullim(height*2+1:height*3,:);
im_notaligned = cat(3,R,G,B);
figure,imshow(im_notaligned)

% crop the borders
Bnew = imcrop(B,[20 20 widht-40 height-40]) ;
Gnew = imcrop(G,[20 20 widht-40 height-40]) ;
Rnew = imcrop(R,[20 20 widht-40 height-40]) ;

%show RGBUnaligned
RGBUN= cat(3,Rnew,Gnew,Bnew);
figure,imshow(RGBUN);

movement = 10;

% find how we should move our images!
offset_r = align_image(Rnew, Gnew, movement);
offset_b = align_image(Bnew, Gnew, movement);

% Actually align our images, and do so on the un-scaled ones.
offset_r = round(offset_r);
offset_b = round(offset_b);

aligned = RGBUN;
aligned(:,:,1) = circshift(RGBUN(:,:,1), offset_r);
aligned(:,:,3) = circshift(RGBUN(:,:,3), offset_b);


% last crop
Bnew = imcrop(aligned(:,:,3),[15 15 widht-30 height-30]) ;
Gnew = imcrop(aligned(:,:,2),[15 15 widht-30 height-30]) ;
Rnew = imcrop(aligned(:,:,1),[15 15 widht-30 height-30]) ;


%show RGB
RGB= cat(3,Rnew,Gnew,Bnew);
figure,imshow(RGB);



